% Get property from the specified object and return the value.
%
% function val = get(self,varargin)
%
% See discussion of the get/set methods in <a href="matlab:helpwin
% 'FAESOR/classes/Contents'">classes/Contents</a>. 
%
function val = get(self,varargin)
    if (nargin == 1)
        val = {{{'eqnums'}, {'cell array of equation numbers, each equation array of dimension [m,1]; for symmetric matrices only'}};
            {{'eqnums_row'}, {'cell array of row equation numbers, each an array [m,1]'}};
            {{'eqnums_col'}, {'cell array of column equation numbers, each an array [n,1]'}};
            {{'mat'}, {'cell array of data matrices, each an array [m,n]'}}};
        return;
    else
        prop_name=varargin{1};
        switch prop_name
            case 'eqnums'
                val = self.eqnums_row;
            case 'eqnums_row'
                val = self.eqnums_row;
            case 'eqnums_col'
                if isempty(self.eqnums_col)
                    val = self.eqnums_row;
                else
                    val = self.eqnums_col;
                end
            case 'mat'
                val = self.mat;
            otherwise
                error(['Unknown property name ''' prop_name '''!']);
        end
    end
end
