% C  PROCEDURE COMPOSES AND ADDS TERMS OF GEOMETRIC STIFFNESS MATRIX
% C  N,Q2,Q3...NORMAL,SHEAR FORCES RESP.
% C  M1,M2,M3...TORQUE,BENDING MOMENTS RESP.,L...ELEMENT LENGTH
%
function SM = local_geometric_stiffness(self,A,I2,I3,PN,L)
    s11=[0,2*PN(3)/L/L,2*PN(5)/L/L;
        2*PN(3)/L/L,6/5*PN(1)/L,0;
        2*PN(5)/L/L,0,6/5*PN(1)/L];
    s12=[0,0,0;
        -(PN(4)+PN(5))/L,PN(6)/L,PN(1)/10;
        (PN(2)+PN(3))/L,-PN(1)/10,PN(6)/L]; s21=s12';
    s13=[0,-2*PN(3)/L/L,-2*PN(5)/L/L;
        -2*PN(3)/L/L,-6/5*PN(1)/L,0;
        -2*PN(5)/L/L,0,-6/5*PN(1)/L]; s31=s13';
    s14=[0,0,0;
        (PN(4)-PN(5))/L,-PN(6)/L,PN(1)/10;
        -(PN(2)-PN(3))/L,-PN(1)/10,-PN(6)/L]; s41=s14';
    s22=[(I2+I3)/A/L*PN(1),-PN(2)/2-PN(3)/6,-PN(4)/2-PN(5)/6;
        -PN(2)/2-PN(3)/6,2*L/15*PN(1),0;
        -PN(4)/2-PN(5)/6,0,2*L/15*PN(1)];
    s23=[0,(PN(4)+PN(5))/L,-(PN(2)+PN(3))/L;
        0,-PN(6)/L,PN(1)/10;
        0,-PN(1)/10,-PN(6)/L]; s32=s23';
    s24=[-(I2+I3)/A/L*PN(1),-PN(3)/3,-PN(5)/3;
        -PN(3)/3,-PN(1)*L/30,PN(6)/2;
        -PN(5)/3,-PN(6)/2,-PN(1)*L/30]; s42=s24';
    s33=[0,2*PN(3)/L/L,2*PN(5)/L/L;
        2*PN(3)/L/L,6/5*PN(1)/L,0;
        2*PN(5)/L/L,0,6/5*PN(1)/L];
    s34=[0,0,0;
        -(PN(4)-PN(5))/L,PN(6)/L,-PN(1)/10;
        (PN(2)-PN(3))/L,PN(1)/10,PN(6)/L]; s43=s34';
    s44=[(I2+I3)/A/L*PN(1),PN(2)/2-PN(3)/6,PN(4)/2-PN(5)/6;
        PN(2)/2-PN(3)/6,2*L/15*PN(1),0;
        PN(4)/2-PN(5)/6,0,2*L/15*PN(1)];
    SM=[s11,s12,s13,s14;
        s21,s22,s23,s24;
        s31,s32,s33,s34;
        s41,s42,s43,s44;
        ];
end
