% Evaluate the volume Jacobian.
%
% function Jac = Jacobian_volume(self, conn, N, J, x)
%
%   For the zero-dimensional cell, the volume Jacobian is the product of the
%    0-D Jacobian and the other dimension (units of length cubed).
%   
%   where
%      self=gcellset,
%      conn=connectivity of a single cell in which the Jacobian is to be evaluated
%      N=values of the basis functions, size(N) = [nbfuns,1]
%      J = Jacobian matrix
%      x=array of spatial coordinates of the nodes, size(x) = [nbfuns,dim]
%
function Jac = Jacobian_volume(self, conn, N, J, x)
    Jac= 1*other_dimension(self, conn, N, x);
end
