% Constructor Of the point geometric cell.
%
% function retobj = gcellset_P1 (varargin)
%
% Class represents a point geometric cell.
% 
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>. 
% Parameters: same as gcellset_0_manifold.
%
function retobj = gcellset_P1 (varargin)
    class_name='gcellset_P1';
    nfens=1;
    if (nargin == 0)
        Parameters.nfens=nfens;
        parent=gcellset_0_manifold(Parameters);
        retobj = class(struct([]),class_name, parent);
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            Parameters=varargin{1}; Parameters.nfens=nfens;
            parent=gcellset_0_manifold(Parameters);
            retobj = class(struct([]),class_name, parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end
