% Draw a graphic representation.
%
% function draw (self, gv, context)
%
%
% Input arguments
% self = self
% gv = graphic viewer
% context = struct
% with mandatory fields
%    x=reference geometry field
%    u=displacement field
% with optional fields
%    facecolor = color of the faces, solid
%    colorfield =field with vertex colors
%       only one of the facecolor and colorfield may be supplied
%    shrink = shrink factor
%
function draw (self, gv, context)
    context.faces=[1 4 3 2];
    context.edges= [1,2,3,4,1];
    node_pc=[-1,-1;1,-1;1,1;-1,1];
    if isfield(context,'shrink')
        if (context.shrink~=1)
            c=ones(size(node_pc,1),1)*(sum(node_pc)/size(node_pc,1));
            pc=c+context.shrink*(node_pc-c);
            for j=1:size(pc,1)
                context.shrunk_pc_N{j}=bfun(self,pc(j,:));
            end
        end
    end
    draw (self.gcellset_2_manifold, gv, context);
end
