% Compute the local coordinate system
%      x=array of spatial coordinates of the nodes, size(x) = [nbfuns,dim]
%      nbfuns=number of nodes (== number of basis functions) per gcell
%             of the class class(g)
function T= local_coordinate_system (self, x, x1x2_vector)
    e1=(x(2,:)-x(1,:))';
    L=norm(e1); 
    if (L <= 0)
        error('Zero-length element');
    end
    e1=e1/L;
    AL=norm(x1x2_vector);
    if (abs(abs(dot(e1,x1x2_vector))-AL)<1e-6*AL)
        error('Element axis is co-linear with the auxiliary x1x2 vector');
    end
    e3=skewmat(e1)*x1x2_vector;
    e3=e3/norm(e3);
    e2=skewmat(e3)*e1;
    T=[e1 e2 e3];
end

