% Constructor for linearly elastic  materials.
%
% function retobj = mater_defor_ss_linel_triax(varargin)
%
% This class represents deformable linearly elastic  materials.
% See discussion of constructors in <a href="matlab:helpwin 'FAESOR/classes/Contents'">classes/Contents</a>. 
% Parameters:
%     property = property object
%
function retobj = mater_defor_ss_linel_triax(varargin)
    class_name='mater_defor_ss_linel_triax';
    if (nargin == 0)
        parent=mater_defor;
        self.property = [];
        retobj = class(self,class_name, parent);
        return;
    elseif (nargin == 1)
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
            return;
        else
            Parameters =varargin{1};
            parent=mater_defor(Parameters);
            self.property = Parameters.property;
            retobj = class(self,class_name, parent);
            return;
        end
    else
        error('Illegal arguments!');
    end
    return;
end
