% Melvin Leok variational integrator constructor. A Lie Group Variational
% Integrator for the Attitude Dynamics of a Rigid Body with Applications to
% the 3D Pendulum (with T.Y. Lee, and N.H. McClamroch), submitted, IEEE
% Conference on Control Applications, 2005.
%
function retobj = rotint_mleok (varargin)
    class_name='rotint_mleok';
    parent=rotint;
    if (nargin == 0)
        self.I = eye(3,3);
        self.R = [];
        self.Omega = [];
        retobj = class(self,class_name,parent);
        return;
    elseif (nargin == 1) % cloning
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
        else
            self.I = eye(3,3);
            self.R = [];
            self.Omega = [];
            retobj = class(self,class_name,parent);
        end
        return;
    else
        error('Illegal arguments!');
    end
    return;
end


