% Newmark integrator constructor.
% Krysl P, Endres L
% Explicit Newmark/Verlet algorithm for time integration of the rotational dynamics of rigid bodies
% INTERNATIONAL JOURNAL FOR NUMERICAL METHODS IN ENGINEERING 62 (15): 2154-2177 APR 21 2005
%     Body-frame version of the gamma=1/2, beta=0,
%     with Newton iteration to solve the eqn of motion.
%   Call as:
%     ri = rotint_nmb
%
function retobj = rotint_nmb (varargin)
    class_name='rotint_nmb';
    parent=rotint;
    if (nargin == 0)
        self.I = eye(3,3);
        self.R = [];
        self.Omega = [];
        retobj = class(self,class_name,parent);
        return;
    elseif (nargin == 1) % cloning
        arg = varargin{1};
        if strcmp(class(arg),class_name) % copy constructor.
            retobj = arg;
        else
            self.I = eye(3,3);
            self.R = [];
            self.Omega = [];
            retobj = class(self,class_name,parent);
        end
        return;
    else
        error('Illegal arguments!');
    end
    return;
end

