% Free-free beam vibration.
%Driverfor the various element types
function result_List=F_circular_plate_driver
    refinements=1:3;
    ns=[1,2];
    %     ns=[10,1,2];
    %     ns=[12,1,2];
    rand('state',0);% try to comment out this line and compare
    %                   results for several subsequent runs
    
    function [fens,gcells] = H8_cylinderdel(L,R,nL,nR);
        [fens,gcells] = T4_cylinderdel(L,R,round(nL/2),round(nR/2));
        [fens,gcells] = T4_to_H8(fens,gcells);
    end
    function [fens,gcells] = T10_cylinderdel(L,R,nL,nR);
        [fens,gcells] = T4_cylinderdel(L,R,nL,nR);
        [fens,gcells] = T4_to_T10(fens,gcells);
    end
    function [fens,gcells] = T11_cylinderdel(L,R,nL,nR);
        [fens,gcells] = T4_cylinderdel(L,R,nL,nR);
        [fens,gcells] = T4_to_T11(fens,gcells);
    end
    function [fens,gcells] = H8_cylinder_structured(L,R,nL,nR);
        [fens,gcells] = H8_cylinder_n(R, L, nR, nL);
    end
    result_List=[];
    
    clear eltyd; eix=1;
    %
    
    %     eltyd(eix).legend ='H8-SRI';
    %     eltyd(eix).mf =@H8_cylinderdel;
    %     eltyd(eix).ns=ns*2;
    %     eltyd(eix).blf =@feblock_defor_ss_sri;
    %     eltyd(eix).integration_rule=gauss_rule (3,[1,2]);
    %     eltyd(eix).styl='md-';
    %     eix=eix+1;
    
    
    %
    %     eltyd(eix).legend ='H8';
    %     eltyd(eix).mf =@H8_block;
    %     eltyd(eix).ns=ns*2;
    %     eltyd(eix).blf =@feblock_defor_ss;
    %     eltyd(eix).integration_rule=gauss_rule (3,2);
    %     eltyd(eix).styl='mx--';
    %     eix=eix+1;
    %
    %     eltyd(eix).legend ='H20R';
    %     eltyd(eix).mf =@H20_block;
    %     eltyd(eix).ns=ns*1;
    %     eltyd(eix).blf =@feblock_defor_ss;
    %     eltyd(eix).integration_rule=gauss_rule (3,2);
    %     eltyd(eix).styl='ro-';
    %     eix=eix+1;
    %
    %     eltyd(eix).legend ='H20';
    %     eltyd(eix).mf =@H20_block;
    %     eltyd(eix).ns=ns*1;
    %     eltyd(eix).blf =@feblock_defor_ss;
    %     eltyd(eix).integration_rule=gauss_rule (3,3);
    %     eltyd(eix).styl='b*-';
    %     eix=eix+1;
    
    %     eltyd(eix).legend ='TREX';
    %     eltyd(eix).mf =@T11_cylinderdel;
    %     eltyd(eix).ns=ns*1;
    %     eltyd(eix).blf =@feblock_defor_ss_t11rex;
    %     eltyd(eix).integration_rule=tet_rule (4);
    %     eltyd(eix).styl='kp-';
    %     eix=eix+1;

    eltyd(eix).legend ='T10';
    eltyd(eix).mf =@T10_cylinderdel;
    eltyd(eix).ns=ns*1;
    eltyd(eix).blf =@feblock_defor_ss;
    eltyd(eix).integration_rule=tet_rule (4);
    eltyd(eix).styl='gd-';
    eix=eix+1;

    %     eltyd(eix).legend ='T4';
    %     eltyd(eix).mf =@T4_block;
    %     eltyd(eix).ns=ns*2;
    %     eltyd(eix).blf =@feblock_defor_ss;
    %     eltyd(eix).integration_rule=tet_rule (1);
    %     eltyd(eix).styl='k^:';
    %     eix=eix+1;
    %
    %
    for eix=1: length(eltyd)
        disp(['Running ' eltyd(eix).legend])
        result=F_circular_plate_do (eltyd(eix),refinements);
        result_List= [result_List, result];
    end
    
    clear eltyd; eix=1;
    eltyd(eix).legend ='NICE-T4-phys';
    eltyd(eix).mf =@T4_cylinderdel;
    eltyd(eix).ns=ns*2;
    eltyd(eix).blf =@feblock_defor_ss_nice_iso;
    eltyd(eix).integration_rule=simplex_nq_rule(3);
    eltyd(eix).stabfact=0.07;
    eltyd(eix).styl='cp-';
    eix=eix+1;
    
    eltyd(eix).legend ='NICE-H8-phys';
    eltyd(eix).mf =@H8_cylinderdel;
    eltyd(eix).ns=ns*2;
    eltyd(eix).blf =@feblock_defor_ss_nice_iso;
    eltyd(eix).integration_rule=tensprod_nq_rule(3);
    eltyd(eix).stabfact=0.015;
    eltyd(eix).styl='ch-';
    eix=eix+1;
    %
    %
    for eix=1: length(eltyd)
        result=F_circular_plate_nice_do (eltyd(eix),refinements);
        result_List= [result_List, result];
    end
    %
    plot_F_circular_plate(result_List)
end