% Curved (45L circular arc) cantilever, Transverse force at the tip
% References:
% Bathe, Boulourchi 1979
% Simo, Vu-Quoc 1986
% Cardona, Geradin 1988
% Krysl 1993

function curved_cantilever
    E=1e7;
    nu=0.0;
    rho=5e-9;
    R= 1;
    sR =100;
    rA=pi/8;
    t= pi/2;
    Fmag=600;

    nincr = 6;
    graphics = ~false;
    cmap = jet;
    scale=1;
    nR =4;
    nt = 1;

    %
    function [fens,gcells] = h8cylH8(t,R, nt,nR)
        [fens,gcells]=block(1.0, pi/4, 1.0, nt,nR,nt);
     end
     function [fens,gcells] = t4cyld(t,R, nt,nR)
        [fens,gcells]=t4blockd(1.0, pi/4, 1.0, nt,nR,nt);
     end
     function [fens,gcells] = t4cyl(t,R, nt,nR)
        [fens,gcells]=t4block(1.0, pi/4, 1.0, nt,nR,nt);
     end
    function [fens,gcells] = h8cylH27(t,R, nt,nR)
        [fens,gcells] = h8cylH8(t,R, nt,nR);
        [fens,gcells] = H8_to_H27(fens,gcells);
    end
    function [fens,gcells] = h8cylH64(t,R, nt,nR)
        [fens,gcells] = h8cylH8(t,R, nt,nR);
        [fens,gcells] = H8_to_H64(fens,gcells);
    end
    
    
    eix=1;
    clear eltyd
    
% eltyd(eix).label ='T4';
% eltyd(eix).mf =@t4cyl;
% eltyd(eix).blf =@feblock_defor_ss;
% eltyd(eix).integration_rule= tet_rule(1);
% eltyd(eix).surface_integration_rule=tri_rule(1);
% eltyd(eix).styl='rv-.';
% eix=eix+1;
% 
% eltyd(eix).label ='H8';
% eltyd(eix).mf =@h8cylH8;
% eltyd(eix).blf =@feblock_defor_nonlinear;
% eltyd(eix).integration_rule= gauss_rule (3,2);
% eltyd(eix).surface_integration_rule=gauss_rule (2,2);
% eltyd(eix).styl='rx-.';
% eix=eix+1;
% 
% eltyd(eix).label ='NICE-T4';
% eltyd(eix).mf =@t4cyl;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule= simplex_nq_rule (3);
% eltyd(eix).surface_integration_rule=tri_rule(1);
% eltyd(eix).styl='m^-';
% eix=eix+1;
% 
% eltyd(eix).label ='NICE-T4d';
% eltyd(eix).mf =@t4cyld;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule= simplex_nq_rule (3);
% eltyd(eix).surface_integration_rule=tri_rule(1);
% eltyd(eix).styl='m^-';
% eix=eix+1;
% % 
% eltyd(eix).label ='NICE-H8';
% eltyd(eix).mf =@h8cylH8;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',1));
% eltyd(eix).styl='md-';
% eix=eix+1;

% 
% eltyd(eix).label ='H27';
% eltyd(eix).mf =@h8cylH27;
% eltyd(eix).blf =@feblock_defor_nonlinear;
% eltyd(eix).integration_rule=gauss_rule (3,3);
% eltyd(eix).surface_integration_rule=gauss_rule(2, 3);
% eltyd(eix).styl='ks-';
% eix=eix+1;
% 

% 
eltyd(eix).label ='H64';
eltyd(eix).mf =@h8cylH64;
eltyd(eix).blf =@feblock_defor_nonlinear;
eltyd(eix).integration_rule=gauss_rule (3,4);
eltyd(eix).surface_integration_rule=gauss_rule(2, 4);
eltyd(eix).styl='ks-';
eix=eix+1;
% 
% eltyd(eix).label ='NICE-H27';
% eltyd(eix).mf =@h8cylH27;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
% eltyd(eix).styl='mh-';
% eix=eix+1;


% eltyd(eix).label ='NICE-H64';
% eltyd(eix).mf =@h8cylH64;
% eltyd(eix).blf =@feblock_defor_nonlinear_nice;
% eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
% eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',3));
% eltyd(eix).styl='mh-';
% eix=eix+1;



    function [neqns,energy] =Compute(nR,nt)
        nus = [(1-1.8.^(-(1:14)))*nu,(1:100)*0+nu];
        %          Mesh
        [fens,gcells] = eltyd(eix).mf (t,R, nt,nR);
        feb = eltyd(eix).blf (struct ('mater',[], 'gcells',gcells));
        [fens, gcells]=renum_mesh_renumber(fens, gcells,...
            renum_mesh_numbering(fens,genconn(feb), 'symamd'));
        bgcells =mesh_bdry(gcells, []);
        icl = gcell_select(fens, bgcells, struct('box', [-Inf,Inf,pi/4,pi/4,-Inf,Inf],'inflate',R/100));
        cncl = fenode_select(fens, struct('box', [-Inf,Inf,pi/4,pi/4,-Inf,Inf],'inflate',R/100));
        for i=1:length (fens)
            xyz=get (fens(i),'xyz');
            x=xyz(1); y=xyz(2); z=xyz(3);
            xyz= [x-sR-0.5, 0, z];
            xyz = xyz*rotmat([0, 0, y])+ [sR+0.5,0,0];
            fens(i)=set(fens(i),'xyz', xyz);
        end
%         gv=drawmesh( {fens,gcells},'facecolor','none'); gv=drawmesh( {fens,bgcells(icl)},'gv',gv,'facecolor','blue');
%         view(3); return
        % Material
        prop = property_linel_iso (struct('E',E,'nu',nu));
        mater = mater_defor_neohook(struct('property',prop));
        % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule));
        efeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells(icl),...
            'integration_rule',eltyd(eix).surface_integration_rule));
        sfeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells,...
            'integration_rule',eltyd(eix).surface_integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        ebc_fenids=fenode_select (fens,struct('box',[-100*sR,100*sR,0,0,-100*sR,100*sR],'inflate',0.1));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);
        u   = apply_ebc (u);

        % Number equations
        u   = numbereqns (u);
        % Now comes the nonlinear solution
        tup = 1;
        u = u*0; % zero out the displacement
        utol = 1000*eps*get(u, 'neqns');
        us={};

        gv=graphic_viewer;
        
        K = start (sparse_altassem_sysmat, get(u, 'neqns'));
%         K = start (sparse_sysmat, get(u, 'neqns'));
           
        t=0; % time=load magnitude
        incr=1;
        while (incr <= nincr)
            t = t + tup / nincr;
            disp(['Increment ' num2str(incr) ]); % pause
            % Initialization
            u1 = u; % guess
            u1 = apply_ebc(u1);
            du = 0*u; % this will hold displacement increment
            du = apply_ebc(du);
            iter=1;
            gv=reset(clear(gv,[]),[]);
            draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
            draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
            while 1
                prop = property_linel_iso (struct('E',E,'nu',nus(iter)));
                mater = mater_defor_neohook(struct('property',prop));
                feb1=set(feb,'mater',mater);
                %                 feb1=feb;                                           % Make a copy of the state
                Load=zeros(3,1); Load(3) =Fmag*t;
                fi=force_intensity(struct('magn',Load));
                F = start (sysvec, get(u, 'neqns'));
                F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
                [feb1,evs] = restoring_force(feb1,geom,u1,u);       % Internal forces
                F = assemble (F, evs);
                ems=stiffness(feb1, geom, u1,u);% Current material stiffness
                ems =cat(2,ems,stiffness_geo(feb1, geom, u1,u)); % Current geometric stiffness
                K = assemble (K, ems);
                K = external_decomposition (K,  []);
                % Displacement increment
                du = scatter_sysvec(du, K\F);
                u1 = u1 + du;                                       % increment displacement
                K = reinitialize (K);
                draw(sfeb,gv, struct ('x', geom,'u',u1, 'facecolor','none'));
                camset(gv, [  -75.6602  613.9688  210.2074   20.6651   38.3517 20.5774         0         0    1.0000    5.3084]);
                pause(1)
                disp(['   It. ' num2str(iter) ': ||du||=' num2str(norm(du))]);
                if (norm(du) < utol) break; end;                    % convergence check
                iter=iter+1;
            end
            [feb,ignore] = restoring_force(feb,geom,u1,u);        % final update
            disp(['    Converged for t=' num2str(t)]); % pause
            u = u1;                                               % update the displacement
            us{end+1} =u;
            utip=gather(u,cncl,'values','noreshape');
            mean(utip)
            incr = incr + 1;
        end
        gv=reset(clear(gv,[]),[]);
        draw(feb,gv, struct ('x', geom,'u',u, 'facecolor','red'));
        draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','Yellow'));
        camset(gv, [  -75.6602  613.9688  210.2074   20.6651   38.3517 20.5774         0         0    1.0000    5.3084]);
                clear K
        save ([mfilename '-nR' num2str(nR) '-nt' num2str(nt) '-' eltyd(eix).label])
    end

    for eix = 1:length(eltyd)
        for i=1:length(nR)
            for j=1:length(nt)
                Compute(nR(i),nt(j));
            end
        end
    end
end