% patch_test
graphics= true;
doeig=~true;
aspect=1;
smult=0;
uc=[-2.0,-1.2,20]'/10;
vc=[1.2,0.0,-30]'/10;
%tension
% uc=[-2,0,0]'/10;
% vc=[0,0,0]'/10;
uc=(rand(3,1)-rand(3,1))/48*10;
vc=(rand(3,1)-rand(3,1))/48*10;

lambda = 0.75e2;
G= 0.375;

Meshf=@t3block2d; ne = 8;
integration_rule =simplex_nq_rule(struct('dim',2,'order',1));
febf =@feblock_defor_ss_nice;
Style ='m^-'; Label='NICE-T3';

% Meshf=@blockT6; ne = 4;
% integration_rule =simplex_nq_rule(struct('dim',2,'order',3));
% febf =@feblock_defor_ss_nice;
% Style ='rh-'; Label='NICE-T6';


%     Meshf=@block2d;
%     integration_rule =tensprod_nq_rule(struct('dim',2,'order',1));
%     febf =@feblock_defor_ss_nice;
%     Style ='md-'; Label='NICE-Q4';

%     Meshf=@blockT6;
%     integration_rule =tri_rule(6);
%     febf =@feblock_defor_ss;
%     Style ='kx-'; Label='T6';

%     Meshf=@block2d;
%     integration_rule = gauss_rule(2, [1 2]);
%     febf =@feblock_defor_ss_sri;
%     Style ='gs-'; Label='Q4-SRI';

nu =1/2*lambda/(G+lambda)
E=G*(3*lambda+2*G)/(G+lambda);

for n=[ne]
    options =struct('other_dimension', 1.0);
    [fens,gcells] = Meshf(48,44, n, aspect*n, options);
    dxy=min(48,44)/n/aspect/100;
    sxy=smult*dxy;
%     rand('state',[0.3085,0.4953,0.0143,0.3137,0.7750,0.8827,0.6275,0.5996,0.3557,0.8033,0.4425,0.3749,0.3086,0.6245,0.0244,0.0309,0.1962,0.2670,0.8672,0.8259,0.3590,0.6446,0.3018,0.6694,0.5783,0.3251,0.0024,0.9082,0.4464,0.0331,0.9344,0.0261,0,0.0000,0.0000]');
%     for i=1:length(fens)
%         xy=get(fens(i),'xyz');
%         if (xy(1)>dxy) & (xy(2)>dxy) & (xy(1)<48-dxy) & (xy(2)<44-dxy)
%             xy=[xy(1)+(2*rand(1)-1)/2*sxy,xy(2)+(2*rand(1)-1)/2*sxy];
%         end
%         fens(i)=set(fens(i),'xyz',xy);
%     end
    for i=1:length(fens)
        xy=get(fens(i),'xyz');
        y=xy(2) + (xy(1)/48)*(44 -xy(2)/44*28);
        fens(i)=set(fens(i),'xyz',[xy(1) y]);
    end
    %     mesh{1}=fens;
    %     mesh{2}=gcells;
    %     drawmesh(mesh); view(2); pause (1)
    propm = property_linel_iso(struct('E',E,'nu', nu));
    mater = mater_defor_ss_linel_biax (struct ('property',propm,'reduction','strain'));
    feb = febf(struct ('mater',mater, 'gcells',gcells, 'integration_rule',integration_rule));

    % Geometry
    geom = field(struct ('name',['geom'], 'dim', 2, 'fens',fens));
    % Define the displacement field
    u   = clone(geom,'u');
    u   = u*0; % zero outfunction five
    % Apply EBC's
    bdry_gcells = mesh_bdry(gcells, struct('other_dimension', 1.0));
    for j=1:length(bdry_gcells)
        conn=get(bdry_gcells(j),'conn');
        for k=1:length(conn)
            xy=get(fens(conn(k)),'xyz');
            u1=xy*uc(1:2)+uc(3);
            v1=xy*vc(1:2)+vc(3);
            %             [u1,v1]
            u   = set_ebc(u, [conn(k),conn(k)], [1,1], [1,2], [u1,v1]);
        end
    end
    u = apply_ebc (u);
    % Number equations
    u   = numbereqns (u);
    % Assemble the system matrix
    K = start (sparse_separow_sysmat, get(u, 'neqns'));
    K = assemble (K, stiffness(feb, geom, u));
    % Load
    F = start (sysvec, get(u, 'neqns'));
    F = assemble (F, nz_ebc_loads(feb, geom, u));
    % Solve
    %         sum(get(F,'vec'))
    x = get(K,'mat')\get(F,'vec');
    u = scatter_sysvec(u, x);
    se= 1/2*x'*get(F,'vec');

    % Plot
    if graphics
        gv=graphic_viewer;
        gv=reset (gv,struct ([]));
        scale=1;
        cmap = gray;
        cmap = jet;
                fld = field_from_integration_points(feb, geom, u, [], 'vol_strain', 1);
%         fld = field_from_integration_points(feb, geom, u, [], 'Cauchy', 1);
        nvals=get(fld,'values');%min(nvals),max(nvals)
        %             max(abs(nvals)), return
        %             nvalsrange=[-0.35 0.15];%[min(nvals),max(nvals)]
        nvalsrange=[min(nvals)-abs(max(nvals)-min(nvals)),max(nvals)+abs(max(nvals)-min(nvals))];
        dcm=data_colormap(struct ('range',nvalsrange, 'colormap',cmap));
        colorfield=field(struct ('name', ['colorfield'], 'data',map_data(dcm, nvals)));
        draw(feb,gv, struct ('x', geom, 'u', scale*u,'colorfield',colorfield, 'shrink',1.0));
        xlabel('X','FontName','Times')
        ylabel('Y','FontName','Times')
        set(gca,'FontSize',14);
        set(gca,'FontName','Times')
        % geom3d=combine (geom, 0*fld);
        % u3d=combine (u, 100000000*fld);
        % draw(feb,gv, struct ('x', geom3d, 'u', +scale*u3d,'colorfield',colorfield, 'shrink',1.0));
        colormap(cmap);
        cbh=colorbar;
        set(cbh,'FontSize',14);
        set(cbh,'FontName','Times')
        set(cbh,...
            'Position',[0.625 0.247 0.035 0.51],...
            'YLim',[0,1],...
            'YTick',[0,1],...
            'YTickLabel',{[num2str(nvalsrange(1))],[num2str(nvalsrange(2))]});%{[num2str((min(nvals)))],[num2str((max(nvals)))]}
        %             set(get(cbh,'XLabel'),'String','Volumetric strain');
        view (2);
        pause(2);close all
        %         for i=1:length(fens)
        %             draw(fens(i),gv, struct ('x', geom, 'u', 0*u, 'facecolor','blue'));
        %         end
        if doeig
            pause(2)
            %% Solve the eigenvibration problem
            neigvs = get(u,'neqns');
            [modes,Omega]=eig(full(a));
            [b,ix]=sort(diag(Omega));

            %% Display the first few eigenvibration modes
            mscale=1;
            w=clone(u,'w'); % make a copy of u
            for i=1:neigvs
                disp(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(ix(i),ix(i))) ]);
                w = scatter_sysvec(w, modes(:,ix(i)));
                wv = get(w,'values');
                wmag = sqrt(wv(:,1).^2+wv(:,2).^2);
                dcm=data_colormap(struct ('range',[min(wmag),max(wmag)], 'colormap',jet));
                colorfield = field(struct ('name',['cf'], 'dim', 3, 'data',map_data(dcm, wmag)));
                for scale=mscale*sin((0:1:42)/21*2*pi)
                    gv=reset (clear (gv),struct ('limits', [-1/40*48 41/40*48 -1/40*60 5/4*60]));
                    %         headlight(gv);
                    draw(feb,gv, struct ('x', geom, 'u', scale*w,'colorfield',colorfield));
                    title(['  Eigenvector ' num2str(i) ' eigenvalue ' num2str(Omega(ix(i),ix(i))) ]);
                    pause(0.01);
                end
                title(['  Next eigenvector: type any key' ]);
                clf;
                pause(2); % next eigenvector
            end
        end
    else
        loglog(h,abs(convutip-utip)/convutip, Style,'lineWIDTH', 3);
        font='Times';
        xlabel ('log(mesh size)')
        ylabel ('log(norm displ error)')
        set(gca,'Position',[0.15 0.15 0.8 0.8]);
        set(gca,'FontSize',14);
        set(gca,'FontName',font)
        l=get(gca,'xlabel');
        set (l,'FontSize',18);
        set(l,'FontName',font)
        l=get(gca,'ylabel');
        set (l,'FontSize',18);
        set(l,'FontName',font)
        hold on; grid on; figure (gcf); pause (2)
    end
end
disp(Label);

