% 
function Argyris_L_linearbuckling
    E = 71240;
    nu=.31;
    %     nu=.0;
    stabfact = 0*E;
    rho=5e-9;
    graphics = ~false;
    Cam =1.0e+003 * [  -1.4407   -0.8522    1.1901    0.1089    0.1350   -0.0492         0         0    0.0010    0.0062];
    scale=1;
    nw = 2;
    nL = 1;
    nt = 1;
    L=255;
    w=30;
    t=0.6;
    Fmag= 1e-5;

    rand('state',0);% try to comment out this line and compare
    %                   results for several subsequent runs
    %
    function [fens,gcells] =  Lframe_Mesh(L,w,t,nw,nL,nt)
        Nodes = [
            1    L-w,0,0
            2    L,0,0
            3     L, L,0
            4     L-w,L-w,0
            5     0,L,0
            6     0,L-w,0
            ];
        [fens1,gcells1] = Q4_quadrilateral(Nodes( [1, 2, 3, 4],2:4),nw,nL,struct('other_dimension',1));
        [fens2,gcells2] = Q4_quadrilateral(Nodes( [4,3,5,6],2:4),nw,nL,struct('other_dimension',1));
        [fens,g1,g2] = merge_meshes(fens1, gcells1, fens2, gcells2, 0.01);
        gcells= cat(g1,g2);
        [fens,gcells] = Q4_extrude(fens,gcells,nt,@(xyz, layer)([xyz(1:2), (t/nt)*(layer-1)]));
    end
    function [fens,gcells] = h8H27(nw,nL)
        [fens,gcells] = Lframe_Mesh(L,w,t,nw,nL,nt);
        [fens,gcells] = H8_to_H27(fens,gcells);
    end
   function [fens,gcells] = h8H20(nw,nL)
        [fens,gcells] = Lframe_Mesh(L,w,t,nw,nL,nt);
        [fens,gcells] = H8_to_H20(fens,gcells);
    end
    function [fens,gcells] = h8H64(nw,nL)
        [fens,gcells] = Lframe_Mesh(L,w,t,nw,nL,nt);
        [fens,gcells] = H8_to_H64(fens,gcells);
    end

    eix=1;
    clear eltyd

    % eltyd(eix).label ='T4';
    % eltyd(eix).mf =@h8T4;
    % eltyd(eix).blf =@feblock_defor_ss;
    % eltyd(eix).integration_rule= tet_rule(1);
    % eltyd(eix).surface_integration_rule=tri_rule(1);
    % eltyd(eix).styl='rv-.';
    % eix=eix+1;
    %
    % eltyd(eix).label ='H8';
    % eltyd(eix).mf =@h8H8;
    % eltyd(eix).blf =@feblock_defor_nonlinear;
    % eltyd(eix).integration_rule= gauss_rule (3,2);
    % eltyd(eix).surface_integration_rule=gauss_rule (2,2);
    % eltyd(eix).styl='rx-.';
    % eix=eix+1;

    %     eltyd(eix).label ='NICE-H8';
    %     eltyd(eix).mf =@h8H8;
    %     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    %     eltyd(eix).integration_rule= tensprod_nq_rule (struct('dim',3,'order',1));
    %     eltyd(eix).surface_integration_rule=tensprod_nq_rule(struct('dim',2,'order',1));
    %     eltyd(eix).styl='rx-.';
    %     eix=eix+1;

    %     eltyd(eix).label ='NICE-T4';
    %     eltyd(eix).mf =@h8T4;
    %     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    %     eltyd(eix).integration_rule= simplex_nq_rule (3);
    %     eltyd(eix).surface_integration_rule=tri_rule(1);
    %     eltyd(eix).styl='m^-';
    %     eix=eix+1;


    % eltyd(eix).label ='NICE-T4d';
    % eltyd(eix).mf =@h8T4d;
    % eltyd(eix).blf =@feblock_defor_nonlinear_nice;
    % eltyd(eix).integration_rule= simplex_nq_doubled_rule (3);
    % eltyd(eix).surface_integration_rule=simplex_nq_doubled_rule (2);
    % eltyd(eix).styl='m^-';
    % eix=eix+1;

            eltyd(eix).label ='H27';
            eltyd(eix).mf =@h8H27;
            eltyd(eix).blf =@feblock_defor_ss_nonlinear;
            eltyd(eix).integration_rule=gauss_rule (3,3);
            eltyd(eix).surface_integration_rule=gauss_rule(2, 3);
            eltyd(eix).styl='ks-';
            eix=eix+1;

%     eltyd(eix).label ='NICE-H27';
%     eltyd(eix).mf =@h8H27;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',2));
%     eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',2));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;

%     eltyd(eix).label ='H20R';
%     eltyd(eix).mf =@h8H20;
%     eltyd(eix).blf =@feblock_defor_nonlinear;
%     eltyd(eix).integration_rule=gauss_rule (3,2);
%     eltyd(eix).surface_integration_rule=gauss_rule(2, 2);
%     eltyd(eix).styl='ro-';
%     eix=eix+1;
    %

%     eltyd(eix).label ='NICE-H64';
%     eltyd(eix).mf =@h8H64;
%     eltyd(eix).blf =@feblock_defor_nonlinear_nice;
%     eltyd(eix).integration_rule=tensprod_nq_rule (struct('dim',3,'order',3));
%     eltyd(eix).surface_integration_rule=tensprod_nq_rule (struct('dim',2,'order',3));
%     eltyd(eix).styl='mh-';
%     eix=eix+1;

    function [Bucklen, Bucklep] =Compute
        %          Mesh
        [fens,gcells] = eltyd(eix).mf (nw, nL);
        %         [fens, gcells]=renum_mesh(fens, gcellsAnd, 'symrcm');
        % Material
        prop = property_linel_iso(struct('E',E,'nu',nu));
        mater = mater_defor_ss_linel_triax(struct('property',prop));
       feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,'integration_rule',eltyd(eix).integration_rule));
        %     [fens, gcells]=renum_mesh_renumber(fens, gcells,...
        %         renum_mesh_numbering(fens,genconn(feb), 'symrcm'));
%         [fens, gcells]=renum_mesh_renumber(fens, gcells,...
%             renum_mesh_numbering(fens,genconn(feb), 'symamd'));
        bgcells =mesh_bdry(gcells, []);
        icl = gcell_select(fens, bgcells, struct('box', [-Inf,Inf,0,0,-Inf,Inf],'inflate',1/100));
        %          gv=drawmesh( {fens,gcells},'facecolor','none'); gv=drawmesh( {fens,bgcells(icl)},'gv',gv,'facecolor','blue');
        %         view(3); pause(1)
         % Finite element block
        feb = eltyd(eix).blf (struct ('mater',mater, 'gcells',gcells,...
            'integration_rule',eltyd(eix).integration_rule));
        efeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',subset(bgcells,icl),...
            'integration_rule',eltyd(eix).surface_integration_rule));
        sfeb = eltyd(eix).blf (struct ('mater',mater, 'gcells',bgcells,...
            'integration_rule',eltyd(eix).surface_integration_rule));
        % Geometry
        geom = field(struct ('name',['geom'], 'dim', 3, 'fens',fens));
        % Define the displacement field
        u   = 0*geom; % zero out
        % Apply EBC's
        %         Bottom surface
        ebc_fenids=fenode_select (fens,struct('box',[0,0,-Inf,Inf,-Inf,Inf],'inflate',1/1000));
        ebc_prescribed=ones(1,length (ebc_fenids));
        ebc_comp=[];
        ebc_val=ebc_fenids*0;
        u   = set_ebc(u, ebc_fenids, ebc_prescribed, ebc_comp, ebc_val);

        u   = apply_ebc (u);

        % Number equations
        u   = numbereqns (u);
        u = u*0; % zero out the displacement



        feb1=feb;                                           % Make a copy of the state
        Traction=zeros(3,1); Traction(1) =Fmag/t/w;
        fi=force_intensity(struct('magn', Traction));
        F = start (sysvec, get(u, 'neqns'));
        F = assemble (F, distrib_loads(efeb, geom, u, fi, 2));
        %         sum (get(F,'vec'))

        K = start (sparse_sysmat, get(u, 'neqns'));
        K = assemble (K, cat(2,...
            stiffness(feb1, geom, u,0*u)));
        u = scatter_sysvec(u, K\F); % Displacement increment
        lnl=fenode_select(fens,struct('box',[-inf inf 0 0 -inf inf]));
        load_displacement=mean(gather(u,lnl,'values','noreshape'));
        if (graphics)
            gv=graphic_viewer;
            gv=reset (gv,[]);
            draw(feb,gv, struct ('x', geom,'u',+100/abs(Fmag)*u));
            draw(feb,gv, struct ('x', geom,'u',0*u, 'facecolor','none'));
         end

        Kgeo = start (sparse_sysmat, get(u, 'neqns'));
        Kgeo = assemble (Kgeo, stiffness_geo(feb1, geom, u,0*u));

        neigvs = 2;
        options.tol =1e-206;
        options.maxit = 5000;
        options.disp = 0;
        [W,Omega]=eigs(-(get(Kgeo,'mat')+get(Kgeo,'mat')')/2,(get(K,'mat')+get(K,'mat')')/2,...
            neigvs,'lm', options);
        diag(Omega)
%         [Omegas,ix]=sort(1./diag(Omega)) ;
       Omegas=(1./(diag(Omega))) 
        Bucklen =Omegas(1); Bucklep=Omegas(2);
        % Plot
        scale=100;
        for i=(1:neigvs)
            phi = scatter_sysvec(u,W(:,i));
            phiv = get(phi,'values');
            norm(get(K,'mat')*gather_sysvec(phi) +Omegas(i)*get(Kgeo,'mat')*gather_sysvec(phi))
            disp(['  Buckling load '  num2str((Omegas(i)*Fmag)) ]);
            %     clf;
            if (graphics)
                gv=graphic_viewer;
                gv=reset (gv,[]);
                scale =L/3/max(abs(gather_sysvec(phi)));
                phivmag = sqrt(phiv(:,1).^2+phiv(:,2).^2+phiv(:,3).^2);
                dcm=data_colormap(struct ('range',[min(phivmag),max(phivmag)], 'colormap',cadcolors));
                colors=map_data(dcm, phivmag);
                colorfield = field(struct ('name',['cf'], 'dim', 3, 'data',colors));
                gv=reset (gv,[]);
                %                 set(gca,'FontSize',16)
                %     camset(gv,[-0.1591    0.0085   -0.3252    0.0001    0.0043    0.0013   -0.8985    0.0237    0.4383    5.4322]);
                draw(feb,gv, struct ('x', geom,'u',0*phi, 'facecolor','none'));
                draw(feb,gv, struct ('x', geom,'u',+scale*phi,'colorfield',colorfield));
                camset(gv,1.0e+003 *[1.9128   -1.0031    0.6488    0.1593    0.1575   -0.0344         0         0    0.0010    0.0048]);
                %     text(0,1.1*R,1.1*R,['\omega_' num2str(i) '=' num2str(sqrt(Omega(i,i))/2/pi) ],'FontSize',24);
            end
        end
    end

    for eix = 1:length(eltyd)
        Bucklens=[]; Buckleps = [];
        for nL = (1:9)
        [Bucklen, Bucklep] = Compute;
        Bucklens=[Bucklens,Bucklen]
        Buckleps = [Buckleps,Bucklep]
        end
        load_displacement
        Bucklens, Buckleps 
    end
end