function test_cappedcylinder_surface1
axis equal
Length=500;
Radius=Length/4;
nperLength=8;
nperRadius=6;
tol=Radius/nperRadius/2/100;
% Make 1/8 of the spherical surface
[fens,gcells]=Q4_sphere_n(Radius,nperRadius,1);
%     Mirror to get 1/4
[fens1,gcells1] = mirror_mesh(fens, gcells, [-1,0,0], [0,0,0], @(c)c([1, 4, 3, 2]));
[fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tol);
gcells=cat(gcells1,gcells2);
%     Mirror again to get 1/2: this is the top cap
[fens1,gcells1] = mirror_mesh(fens, gcells, [0,-1,0], [0,0,0], @(c)c([1, 4, 3, 2]));
[fens,gcells1,gcells2] = merge_meshes(fens1, gcells1, fens, gcells, tol);
tgcells=cat(gcells1,gcells2);
tfens=fens;
%     Mirror to get the bottom cap
[bfens,bgcells] = mirror_mesh(tfens, tgcells, [0,0,-1], [0,0,0], @(c)c([1, 4, 3, 2]));
% Extract the circle boundary
bcgcells=mesh_bdry(bgcells);
% extrude the circular boundary to create the cylindrical surface
[cfens,cgcells] = L2_extrude(fens,bcgcells,nperLength,...
    @(xyz, layer)xyz+[0,0,(layer/nperLength)*Length]);
% Translate the top cap
tfens = transform_apply(tfens,@(x,d)x+[0,0,Length], []);
% Merge everything together
[fens,gcells1,gcells2] = merge_meshes(tfens, tgcells, bfens, bgcells, tol);
gcells=cat(gcells1,gcells2);
[fens,gcells1,gcells2] = merge_meshes(fens, gcells, cfens, cgcells, tol);
gcells=cat(gcells1,gcells2);
% Shift downwards to center the geometry
fens = transform_apply(fens,@(x,d)x+[0,0,-Length/2], []);

% Convert to triangles
[fens,gcells] = Q4_to_T3(fens,gcells,struct( 'other_dimension', 1 ));
% Retrieve output arrays
xyz=get(fens, 'xyz' );
conn=get(gcells,'conn' );
% Produce a plot
h=patch('Faces', conn, ...
    'Vertices', xyz,'BackFaceLighting','lit',...
    'AmbientStrength',0.75,...
    'FaceColor', 'r','EdgeColor','k');

bdgcells=mesh_bdry(gcells,struct('other_dimension', 100 ));
if (count (bdgcells)>0)
    error('Inconsistent mesh: merging failed');
end
%  drawmesh({fens,bdgcells},'gcells', 'facecolor', 'y')
end