% Run all verification examples.
% 
% function run_verification
% 
% The examples in the folders from the verification_list (see below) are
% all run automatically. The results of the verification suite are recorded
% in a log file in the working directory.
% 
% The function run_all_examples is invoked to carry out the computation.
% 
function run_verification
    verification_list={'simple_graphics','miscellaneous','mesh_gen',...
        'taut_wire','heat_diffusion',...
        'stress','thermo_mechanical','thermal_electrical','electro_thermo_mechanical',...
        'instability','corot_beam','acoustics'};
    %verification_list={'corot_beam','acoustics'};
    for i=1:length(verification_list)
        verification_list{i}=[FAESOR_path filesep 'examples' filesep verification_list{i}];
    end 
    run_all_examples(verification_list);
end