function use_axes
    hfigure = figure('Name','use_axes');
    
    haxes1 = axes(...
        'Parent',hfigure,...
        'Units','normalized',...
        'Position',[0.05 0.1 0.4 0.8]);
    
    hbutton = uicontrol(...
        'Parent',hfigure,...
        'Units','normalized',...
        'BackgroundColor',[0.831 0.816 0.784],...
        'Callback',@pushbutton_Callback,...
        'Position',[0.33 0.95 0.302961275626424 0.03],...
        'String','Switch axes');
    
    haxes2 = axes(...
        'Parent',hfigure,...
        'Units','normalized',...
        'Position',[0.05+0.4+0.1 0.1 0.4 0.8]);
    
    gv=graphic_viewer;
    gv=reset (gv,struct('axes', haxes2));
    x=[-1 -1 0];
    v=(-2:2);
    dcm=data_colormap(struct ('range',[min(v),max(v)], 'colormap',jet));
    colors=map_data(dcm, v);
    draw_cylinder(gv,x,x+3, 0.1, 0.1, struct ('facecolor','red'));
    draw_cylinder(gv,x,x+[4 0 0], 0.11, 0.2, struct ('facecolor','Green'));
    draw_cylinder(gv,x,x+[0 4 0], 0.31, 0., struct ('facecolor','blue'));
    rotate(gv,[]);
    
    % --- Executes on button press in pushbutton1.
    function pushbutton_Callback(hObject, eventdata, handles)
        % hObject    handle to pushbutton1 (see GCBO)
        % eventdata  reserved - to be defined in a future version of MATLAB
        % handles    structure with handles and user data (see GUIDATA)
        if (get(gv, 'axes' )==haxes2)
            new=haxes1; old=haxes2;
        else
            new=haxes2; old=haxes1;
        end
        axes(old);
        cla;
        gv=reset (gv,struct('axes', new));
        draw_cylinder(gv,x,x+3, 0.1, 0.1, struct ('facecolor','red'));
        draw_cylinder(gv,x,x+[4 0 0], 0.11, 0.2, struct ('facecolor','Green'));
        draw_cylinder(gv,x,x+[0 4 0], 0.31, 0., struct ('facecolor','blue'));
        rotate(gv,[]);
    end
end