% Tetrahedral (t4) Mesh of a block located in a given range. This function
% comes with a companion, t4blockb.  They produce meshes of the same block
% where the orientation of the elements differs by a 90 degree angle.
% The mesh is produced by splitting each logical block into five
% tetrahedra.
%
% function [fens,gcells] = t4blocka(Length,Width,Height,nL,nW,nH)
%
% Range =<0,Length> x <0,Width> x <0,Height>
% Divided into elements: nL, nW, nH in the first, second, and
% third direction (x,y,z).
% 
% Example: run test_t4block
% 
function [fens,gcells] = t4blockrandom(Length,Width,Height,nL,nW,nH)
    [fens,gcells] = block(Length,Width,Height,nL,nW,nH);
    [fens,gcells] = H8_to_T4_random(fens,gcells)