% This is to fix a bug in Matlab versions before 7.6, where matrices
% that were unsymmetric by just numerical imprecision were treated as truly
% nonsymmetric.
function  [W,Omega] = eigssym(K,M,neigvs,sigma, options)
if verLessThan('matlab', '7.6.0')
    K= (K+K')/2;
    M= (M+M')/2;
end
[W,Omega]= eigs(K,M,neigvs,sigma, options);
end